conf - Initialize modern autotools projects
===========================================

Inspired by Mozilla Cargo ( http://doc.crates.io/guide.html )
but without the NIH and currently more limited in scope.

See NEWS for user-visible changes.
See ChangeLog or the history for detailed changes.

## Usage: Create a new project

    conf new hello_world  --lang bash

Currently implemented languages: 

- bash (full): script with resources
- guile scheme
- python (partial)
- latex-copernicus: write a paper for a copernicus journal

## adding a new language

Adding new languages requires adding the relevant extensions to 
the configure.ac and Makefile.am templates.

For a language named LANGUAGE, create the directory templates/LANGUAGE
including files that use _TEMPLATE_AUTHOR_ for the user name and
_TEMPLATE_PROJ_ for the project name.

Files and folders named _TEMPLATE_PROJ_* will be renamed to the
project name. For example with a project named foo,
`_TEMPLATE_PROJ_.py` will be renamed `foo.py`

You can build upon the generic files in templates/ (i.e. configure.ac)
by creating *.head and *.tail files (i.e. configure.ac.tail,
Makefile.am.head, Makefile.am.tail). These will then be used as begin
(head) or end (tail) of the generated files.

For complex file structures, you might have to adjust conf.in to
create the appropriate file structure. Look for `test x"${PROJLANG}"`
to find the place to edit.

For inspiration, look into template/bash since that includes some
necessary tricks to access data paths with autotools under bash.

## build conf

    ./bootstrap.sh ; make

## Install

    ./bootstrap.sh && make install

To install only for the current user, use

    ./bootstrap.sh --prefix=$HOME/.local && make install

Also see

    make help

For details on installing a release, see INSTALL

## Contributors

See AUTHORS

## Release Process

* Check/Update NEWS
* Increase version in configure.ac (see semver.org)
* Commit, merge to stable and tag (see branching[^1])

        ./bootstrap.sh && make distcheck

[^1]: maintainer action "do a release" in
      <http://www.draketo.de/branching-strategy#action-maintainer>

## Planning

We need bash for Makefiles, so we can use bash for scripting.
